package org.example.basictrekking;


import android.app.NotificationManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.internal.view.ContextThemeWrapper;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;

import java.io.File;
import java.util.Calendar;
import java.util.Date;


public class MainActivity extends AppCompatActivity{
    private Button MapaButton;
    private ImageButton FotoButton;
    private Button ServicioButton;
    private Button PararServicio;
    public static AlmacenTracks almacen;
    public static String fechaTrack;
    private Uri uriFoto;
    private static String FICHERO;
    final static int RESULTADO_FOTO = 1;
    public static File ficheroFoto;
    public static String nombreFoto = "foto";

    private static PhotosDB photosDB;
    public static int ultimaFoto;

    private static boolean destruida = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        findViewById(R.id.fondo).getBackground().setAlpha(200);
        MapaButton = (Button)findViewById(R.id.boton_mapa);
        MapaButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                listadoTracks(null);
            }
        });
        FotoButton = (ImageButton)findViewById(R.id.boton_foto);
        FotoButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                tomarFoto(null);
            }
        });
        ServicioButton = (Button)findViewById(R.id.boton_servicio);
        ServicioButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                lanzarTrack(null);
            }
        });
        PararServicio = (Button)findViewById(R.id.parar_servicio);
        PararServicio.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                stopService(new Intent(MainActivity.this,
                        ServicioTrack.class));
                FotoButton.setVisibility(View.INVISIBLE);
                PararServicio.setVisibility(View.INVISIBLE);
                ServicioButton.setVisibility(View.VISIBLE);
            }
        });
        almacen = new AlmacenTracksSQLite(this);
    }

    @Override protected void onResume() {
        //Toast.makeText(this, "Aplicación reabierta", Toast.LENGTH_LONG).show();
        super.onResume();

        if(destruida == true) {
            int estado1 = 0;
            int estado2 = 0;
            int estado3 = 0;

            // Salvamos el estado de los botones
            SharedPreferences preferencias = this.getSharedPreferences(
                    "estado1", Context.MODE_PRIVATE);
            estado1 = preferencias.getInt("estado1", 0);

            SharedPreferences preferencias2 = this.getSharedPreferences(
                    "estado2", Context.MODE_PRIVATE);
            estado2 = preferencias2.getInt("estado2", 0);

            SharedPreferences preferencias3 = this.getSharedPreferences(
                    "estado3", Context.MODE_PRIVATE);
            estado3 = preferencias3.getInt("estado3", 0);

            if (estado1 == 0)
                ServicioButton.setVisibility(View.VISIBLE);
            else
                ServicioButton.setVisibility(View.INVISIBLE);

            if (estado2 == 0)
                PararServicio.setVisibility(View.VISIBLE);
            else
                PararServicio.setVisibility(View.INVISIBLE);

            if (estado3 == 0)
                FotoButton.setVisibility(View.VISIBLE);
            else
                FotoButton.setVisibility(View.INVISIBLE);

            destruida = false;
        }
    }

    @Override protected void onDestroy() {
        //Toast.makeText(this, "Aplicación destruida", Toast.LENGTH_LONG).show();
        super.onDestroy();
        destruida = true;
        almacenarEstado();
    }

    public void almacenarEstado()
    {

        int estado1 = ServicioButton.getVisibility();
        int estado2 = PararServicio.getVisibility();
        int estado3 = FotoButton.getVisibility();

        // Salvamos el estado de los botones
        SharedPreferences preferencias =this.getSharedPreferences(
                "estado1", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = preferencias.edit();
        editor.putInt("estado1", estado1);
        editor.commit();

        SharedPreferences preferencias2 =this.getSharedPreferences(
                "estado2", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor2 = preferencias2.edit();
        editor2.putInt("estado2", estado2);
        editor2.commit();

        SharedPreferences preferencias3 =this.getSharedPreferences(
                "estado3", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor3 = preferencias3.edit();
        editor3.putInt("estado3", estado3);
        editor3.commit();

    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        switch(id)
        {
            case R.id.action_settings:
                lanzarPreferencias(null);
                return true;
            case R.id.acercaDe:
                lanzarAcercaDe(null);
                return true;
            case R.id.menu_buscar:
                lanzarBusquedaWeb(null);
                return true;
            case R.id.salir:
                confirmarSalida(null);
                return true;
        }

        return super.onOptionsItemSelected(item);
    }

    public void lanzarAcercaDe(View view){
        Intent i = new Intent(this, AcercaDe.class);
        startActivity(i);
    }

    public void lanzarPreferencias(View view){
        Intent i = new Intent(this, Preferencias.class);
        startActivity(i);
    }

    public void lanzarBusquedaWeb(View view) {
        Intent intent = new Intent(Intent.ACTION_VIEW,
                Uri.parse(getString(R.string.wikiloc)));
        startActivity(intent);
    }

    public void salir(View view) {
        //Paramos el servicio antesde salir de la aplicación
        stopService(new Intent(MainActivity.this,
                ServicioTrack.class));
        //Borramos notificación
        NotificationManager notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
        notificationManager.cancel(ServicioTrack.ID_NOTIFICACION_TRACK);
        finish();
    }

    public void confirmarSalida(View view) {

        new AlertDialog.Builder(new ContextThemeWrapper(this, R.style.AlertDialogCustom))
                .setTitle(getString(R.string.tituloSalida))
                .setMessage(getString(R.string.mensajeSalida))
                .setPositiveButton(getString(R.string.Aceptar), new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        salir(null);
                    }
                })
                .setNegativeButton(getString(R.string.Cancelar), new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        //Log.i("Dialogos", "Salida cancelada.");
                        dialog.cancel();
                    }
                })
                .setIcon(android.R.drawable.ic_dialog_alert)
                .show();
    }

    public void tomarFoto(View view) {
        Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");
        FICHERO =  Environment.getExternalStorageDirectory() + "/Android/data/org.example.basictrekking/files/";
        File ruta = new File(FICHERO);
        if (!ruta.exists()) {
            ruta.mkdirs();
        }
        FICHERO = FICHERO + "img_" + (System.currentTimeMillis() / 1000) + ".jpg";
        ficheroFoto = new File(FICHERO);
        uriFoto = Uri.fromFile(ficheroFoto);

        //Almacenamos el nombre de la foto en un fichero de preferencias
        SharedPreferences preferencias4 =this.getSharedPreferences(
                "foto", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor4 = preferencias4.edit();
        editor4.putString("foto", uriFoto.toString());
        editor4.commit();

        intent.putExtra(MediaStore.EXTRA_OUTPUT, uriFoto);
        sendBroadcast(intent);
        startActivityForResult(intent, RESULTADO_FOTO);
    }

    @Override protected void onActivityResult (int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if (requestCode==RESULTADO_FOTO && resultCode==RESULT_OK /*&& uriFoto!= null*/)
        {
            //Tomamos el nombre de la foto de un fichero de preferencias
            SharedPreferences preferencias4 = this.getSharedPreferences(
                    "foto", Context.MODE_PRIVATE);
            nombreFoto = preferencias4.getString("foto", "");

            // Para almacenar la foto en una base de datos
            ////nombreFoto = uriFoto.toString();
            ultimaFoto = nuevaFoto();
        }
    }

    public void listadoTracks(View view)
    {
        Intent i = new Intent(this,Tracks.class);
        startActivity(i);
    }

    public void lanzarTrack(View view) {
        final EditText track = new EditText(this);

        track.setHint(R.string.dialogoHintRuta);

        new AlertDialog.Builder(new ContextThemeWrapper(this, R.style.AlertDialogCustom))
                .setTitle(getString(R.string.dialogoTitulo))
                .setMessage(getString(R.string.dialogoMensaje))
                .setView(track)
                .setPositiveButton(getString(R.string.Aceptar), new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        ServicioTrack.nombre = track.getText().toString();
                        String dt;
                        Date cal = (Date) Calendar.getInstance().getTime();
                        dt = cal.toLocaleString();
                        fechaTrack = dt.toString();
                        almacen.guardarTrack(ServicioTrack.nombre, MainActivity.fechaTrack);
                        // Queremos avisar cuando sea válido
                        ServicioTrack.GPSvalido = false;
                        startService(new Intent(MainActivity.this, ServicioTrack.class));

                        FotoButton.setVisibility(View.VISIBLE);
                        PararServicio.setVisibility(View.VISIBLE);
                        ServicioButton.setVisibility(View.INVISIBLE);
                    }
                })
                .setNegativeButton(getString(R.string.Cancelar), null)
                .setIcon(android.R.drawable.ic_menu_edit)
                .show();

    }

    public int nuevaFoto() {
        int id = -1;
        photosDB = new PhotosDB(this);
        SQLiteDatabase bd = photosDB.getWritableDatabase();
        bd.execSQL("INSERT INTO photos (track, foto, latitud, longitud) " + "VALUES ('" + ServicioTrack.nombre + "', '" + nombreFoto + "', " + ServicioTrack.latitud + ", " + ServicioTrack.longitud + ")");

        Cursor c = bd.rawQuery("SELECT _id FROM photos WHERE foto = '" + nombreFoto +"'", null);
        if (c.moveToFirst()){
            id = c.getInt(0);
        }

        c.close();
        bd.close();
        return id;
    }
}

