package org.example.basictrekking;

import android.app.Activity;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import java.io.FileNotFoundException;
import java.util.Vector;

/**
 * Created by Cristina on 10/11/2015.
 */
public class MiAdaptador extends BaseAdapter {
    private final Activity actividad;
    private final Vector<String> lista;

    private String titulo = "Track";
    private String subtitulo = "Date";
    private String nombreIcono = "foto";

    public MiAdaptador(Activity actividad, Vector<String> lista) {
        super();
        this.actividad = actividad;
        this.lista = lista;
    } public View getView(int position, View convertView, ViewGroup parent) {
        LayoutInflater inflater = actividad.getLayoutInflater();
        View view = inflater.inflate(R.layout.elemento_lista, null, true);

        AlmacenTracksSQLite TracksDB = new AlmacenTracksSQLite(actividad);
        SQLiteDatabase db = TracksDB.getReadableDatabase();
        Cursor cursor = db.rawQuery("SELECT * FROM tracks", null);
        int indice = (cursor.getCount()-position)-1;
        PhotosDB photosDB = new PhotosDB(actividad);

        for(int i = 0; i <cursor.getCount(); i++) {
            if (cursor.moveToPosition(indice)) {
                titulo = cursor.getString(1);
                subtitulo = cursor.getString(2);


                // Insertamos la foto
                SQLiteDatabase db1 = photosDB.getReadableDatabase();
                Cursor cursor1 = db1.rawQuery("SELECT * FROM photos WHERE track = '" + titulo + "'", null);
                //Cursor cursor1 = db1.rawQuery("SELECT * FROM photos", null);
                if (cursor1.moveToFirst()){
                    //id = c.getInt(0);
                    nombreIcono = cursor1.getString(2);
                }
                else
                    nombreIcono = "foto";
                //Cerramos el cursor y la base de datos
                cursor1.close();
                db1.close();
            }
        }

        //Cerramos el cursor y la base de datos
        cursor.close();
        db.close();

        TextView textView =(TextView)view.findViewById(R.id.titulo);
        textView.setText(titulo);
        TextView textView1 =(TextView)view.findViewById(R.id.subtitulo);
        textView1.setText(subtitulo);

        ImageView imageView=(ImageView)view.findViewById(R.id.icono);
        if(!nombreIcono.equals("foto"))
            imageView.setImageBitmap(reduceBitmap(actividad,nombreIcono,128,128));

        // Aquí es donde hay que poner el código para que coja la foto
        // En elemento_lista.xml estará la foto por defecto
        //imageView.setImageResource(R.mipmap.ic_launcher);

        return view;
    }

    public int getCount() {
        return lista.size();
    }

    public Object getItem(int arg0) {
        return lista.elementAt(arg0);
    }

    public long getItemId(int position) {
        return position;
    }

    public static Bitmap reduceBitmap(Context contexto, String uri,
                                      int maxAncho, int maxAlto) {
        try {
            final BitmapFactory.Options options = new BitmapFactory.Options();
            options.inJustDecodeBounds = true;
            BitmapFactory.decodeStream(contexto.getContentResolver()
                    .openInputStream(Uri.parse(uri)), null, options);
            options.inSampleSize = (int) Math.max(
                    Math.ceil(options.outWidth / maxAncho),
                    Math.ceil(options.outHeight / maxAlto));
            options.inJustDecodeBounds = false;
            return BitmapFactory.decodeStream(contexto.getContentResolver()
                    .openInputStream(Uri.parse(uri)), null, options);
        } catch (FileNotFoundException e) {
            Toast.makeText(contexto, R.string.noFile,
                    Toast.LENGTH_LONG).show();
            e.printStackTrace();
            return null;
        }
    }
}
