package org.example.basictrekking;


import android.app.Notification;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.BitmapFactory;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.IBinder;
import android.preference.PreferenceManager;
import android.support.v4.app.NotificationCompat;
import android.widget.Toast;

import com.google.android.gms.maps.model.LatLng;


/**
 * Created by Cristina on 09/11/2015.
 */
public class ServicioTrack extends Service implements LocationListener{
    public static final int ID_NOTIFICACION_TRACK = 1;
    private long tiempoMin;
    private long distanciaMin;
    private LocationManager manejador;
    private String proveedor;
    public static double latitud = 0.0;
    public static double longitud = 0.0;
    public static int ultimoElemento;
    private static WaypointsDB WaypointsDB;
    public static String nombre;
    private SharedPreferences pref;

    public static boolean GPSvalido;

    @Override public void onCreate() {
        super.onCreate();
    }
    @Override
    public int onStartCommand(Intent intenc, int flags, int idArranque) {
        // Capturamos preferencias de usuario
        pref = PreferenceManager. getDefaultSharedPreferences(this);
        tiempoMin = Integer.valueOf(pref.getString("tiempo", "60"));
        // Pasamos el tiempo a milisegundos
        tiempoMin = tiempoMin * 1000;
        distanciaMin = Integer.valueOf(pref.getString("tiempo", "10"));

        manejador = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        proveedor = LocationManager.GPS_PROVIDER;
        Location localizacion = manejador.getLastKnownLocation(proveedor);
        WaypointsDB = new WaypointsDB(this);
        manejador.requestLocationUpdates(proveedor, tiempoMin, distanciaMin, this);
        //manejador.requestLocationUpdates(proveedor, TIEMPO_MIN, DISTANCIA_MIN, this);

        Toast.makeText(this, R.string.gpsNo, Toast.LENGTH_LONG).show();
        return START_NOT_STICKY;
    }
    @Override public void onDestroy() {
        manejador.removeUpdates(this);

        // Cuando finaliza el servicio, eliminamos la notificación
        NotificationManager notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
        notificationManager.cancel(ID_NOTIFICACION_TRACK);

    }
    @Override public IBinder onBind(Intent intencion) {
        return null;
    }

    @Override
    public void onLocationChanged(Location location) {
        latitud = location.getLatitude();
        longitud = location.getLongitude();

        if (GPSvalido == false) {
            Toast.makeText(this, R.string.gpsValido, Toast.LENGTH_LONG).show();
            // Creamos una notificación cuando tenenmos señal GPS válida
            NotificationCompat.Builder notific = new NotificationCompat.Builder(this) .setContentTitle(nombre)
                    .setSmallIcon(R.mipmap.ic_launcher)
                    .setContentText(getString(R.string.notificacionText))
                    .setLargeIcon(BitmapFactory.decodeResource(getResources(),
                            R.mipmap.ic_launcher))
                    .setWhen(System.currentTimeMillis())
                    .setContentInfo(getString(R.string.notificacionInfo))
                    .setTicker(getString(R.string.notificacionTicker))
                    .setDefaults(Notification.DEFAULT_LIGHTS)
                    .setVibrate(new long[]{0, 100, 200, 300});

            // Actividad que lanzaremos si se pulsa la notificación
        /*PendingIntent intencionPendiente = PendingIntent.getActivity(this, 0, new Intent(this, Tracks.class), 0);
        notific.setContentIntent(intencionPendiente);*/

            NotificationManager notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
            notificationManager.notify(ID_NOTIFICACION_TRACK, notific.build());

            GPSvalido = true;
        }

        LatLng waypoint = new LatLng(latitud, longitud);
        //Almacenamos el punto en la base de datos
        ultimoElemento = nuevoWaypoint();
    }

    @Override
    public void onStatusChanged(String provider, int status, Bundle extras) {

    }

    @Override
    public void onProviderEnabled(String provider) {

    }

    @Override
    public void onProviderDisabled(String provider) {
        Intent intent = new Intent( android.provider.Settings.ACTION_LOCATION_SOURCE_SETTINGS);
        startActivity(intent);
    }
    public int nuevoWaypoint() {
        int id = -1;
        SQLiteDatabase bd = WaypointsDB.getWritableDatabase();
        bd.execSQL("INSERT INTO waypoints (nombre, latitud, longitud) "+ "VALUES ( '"+nombre+"', "+latitud+", "+longitud+")");

        Cursor c = bd.rawQuery("SELECT _id FROM waypoints WHERE longitud = " + longitud, null);
        if (c.moveToFirst()){
            id = c.getInt(0);
        }

        c.close();
        bd.close();
        return id;
    }
}
