package org.example.basictrekking;

import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

/**
 * Created by Cristina on 10/11/2015.
 */
public class Tracks extends ListActivity {
    private static MiAdaptador adaptador;
    public static String nombreTracklista;
    private static AlmacenTracksSQLite TracksDB;
    private static WaypointsDB WaypointsDB;
    private static PhotosDB PhotosDB;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.tracks);

        adaptador = new MiAdaptador(this, MainActivity.almacen.listaTracks(10));
        setListAdapter(adaptador);

        ListView lv = getListView();
        lv.setOnItemLongClickListener(new AdapterView.OnItemLongClickListener() {
            @Override
            public boolean onItemLongClick(AdapterView<?> arg0, View arg1, int row, long arg3) {
                borrarWaypoints(row);
                return true;
            }
        });
    }

    @Override
    protected void onListItemClick(ListView listView, View view, int position, long id) {
        super.onListItemClick(listView, view, position, id);

        // Buscamos el elemento seleccionado en la lista de tracks
        TracksDB = new AlmacenTracksSQLite(this);
        SQLiteDatabase db = TracksDB.getReadableDatabase();
        Cursor cursor = db.rawQuery("SELECT * FROM tracks", null);
        int indice = (cursor.getCount()-position)-1;
        if (cursor.moveToPosition(indice)){
            nombreTracklista = cursor.getString(1);
        }

        //Cerramos el cursor y la base de datos
        cursor.close();
        db.close();

        // Dibujamos el track correspondiente
        lanzarMapa(null);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        //getMenuInflater().inflate(R.menu.menu_puntuaciones, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        return super.onOptionsItemSelected(item);
    }

    public void lanzarMapa(View view)
    {
        Intent i = new Intent(this,MapaTrack.class);
        startActivity(i);
    }

    public void borrarWaypoints(int position) {
        String nombre;
        TracksDB = new AlmacenTracksSQLite(this);
        SQLiteDatabase bd = TracksDB.getWritableDatabase();
        Cursor cursor = bd.rawQuery("SELECT * FROM tracks", null);
        int indice = (cursor.getCount()-position)-1;
        if (cursor.moveToPosition(indice)){
            WaypointsDB = new WaypointsDB(this);
            SQLiteDatabase bd1 = WaypointsDB.getWritableDatabase();
            PhotosDB = new PhotosDB(this);
            SQLiteDatabase bd2 = PhotosDB.getWritableDatabase();
            nombre = cursor.getString(1);
            // Borramos el track correspondiente
            bd.execSQL("DELETE FROM tracks WHERE nombre = '" + nombre + "'");
            bd.close();
            // Borramos los waypoints correspondientes
            bd1.execSQL("DELETE FROM waypoints WHERE nombre = '" + nombre + "'");
            bd1.close();
            //Borramos la referencia a las fotos correspondientes
            bd2.execSQL("DELETE FROM photos WHERE track = '" + nombre + "'");
            bd2.close();
        }
        cursor.close();
        //Actualizamos el ListView
        adaptador = new MiAdaptador(this, MainActivity.almacen.listaTracks(10));
        setListAdapter(adaptador);
        adaptador.notifyDataSetChanged();
    }
}
