package org.example.basictrekking;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

/**
 * Created by Cristina on 09/11/2015.
 */
public class WaypointsDB extends SQLiteOpenHelper {
    /** Nombre de la base de datos */
    private static String DBNAME = "waypointsSQLite";

    /** Versión de la base de datos */
    private static int VERSION = 1;

    /** SQLiteDatabase */
    private SQLiteDatabase waypointsDB;

    /** Constructor */
    public WaypointsDB(Context context) {
        super(context, DBNAME, null, VERSION);
        this.waypointsDB = getWritableDatabase();
    }

    /** This is a callback method, invoked when the method getReadableDatabase() / getWritableDatabase() is called
     * provided the database does not exists
     * */
    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL("CREATE TABLE waypoints (" +
                "_id INTEGER PRIMARY KEY AUTOINCREMENT, " +
                "nombre TEXT, " +
                "latitud REAL, " +
                "longitud REAL, " +
                "foto TEXT, " +
                "fecha DEFAULT CURRENT_TIMESTAMP)");
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
    }

}

